import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React from 'react';
import { mount } from 'enzyme';
import { Radio } from '..';
import mountTest from '../../../tests/shared/mountTest';
describe('Radio', function () {
  mountTest(Radio);
  it('should emit "update:modelValue" event when radio icon or label is clicked', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
    var onClick, wrapper, icon, label;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            onClick = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Radio, {
              name: "a",
              onClick: onClick,
              defaultChecked: false
            }, "\u5355\u9009\u6846"));
            icon = wrapper.find('.rc-radio__icon');
            label = wrapper.find('.rc-radio__label');
            icon.simulate('click');
            expect(onClick).toHaveBeenCalledTimes(1);
            _context.next = 8;
            return wrapper.setProps({
              checked: false
            });

          case 8:
            label.simulate('click');
            expect(onClick).toHaveBeenCalledTimes(2);

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  it('should not emit "update:modelValue" event when radio icon is disabled and clicked', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
    var onChange, wrapper;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            onChange = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Radio, {
              name: "a",
              onChange: onChange,
              defaultChecked: true,
              disabled: true
            }, "\u5355\u9009\u6846"));
            wrapper.find('.rc-radio__icon').simulate('click');
            expect(onChange).not.toHaveBeenCalled();

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  it('should render "rc-radio--label-disabled" class when using label-disabled prop', function () {
    var wrapper = mount( /*#__PURE__*/React.createElement(Radio, {
      name: "a",
      defaultChecked: true,
      labelDisabled: true
    }, "\u5355\u9009\u6846"));
    expect(wrapper.find('.rc-radio--label-disabled')).toBeTruthy();
  });
  it('should not emit "update:modelValue" event when label is disabled and clicked', function () {
    var onChange = jest.fn();
    var wrapper = mount( /*#__PURE__*/React.createElement(Radio, {
      name: "a",
      onChange: onChange,
      defaultChecked: true,
      labelDisabled: true
    }, "\u5355\u9009\u6846"));
    var label = wrapper.find('.rc-radio__label');
    label.simulate('click');
    expect(onChange).not.toHaveBeenCalled();
  });
  it('should adjust label position when using label-position prop', function () {
    var wrapper = mount( /*#__PURE__*/React.createElement(Radio, {
      name: "a",
      defaultChecked: true,
      labelPosition: "left"
    }, "\u5355\u9009\u6846"));
    expect(wrapper.find('.rc-radio__label--left')).toBeTruthy();
  });
  it('should emit click event when radio icon is clicked', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
    var onClick, wrapper;
    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            onClick = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Radio, {
              name: "a",
              defaultChecked: true,
              onClick: onClick
            }, "\u5355\u9009\u6846"));
            wrapper.simulate('click');
            expect(onClick).toHaveBeenCalled();

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
});