"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _enzyme() {
  var data = require("enzyme");

  _enzyme = function _enzyme() {
    return data;
  };

  return data;
}

var _ = require("..");

var _mountTest = _interopRequireDefault(require("../../../tests/shared/mountTest"));

describe('Radio', function () {
  (0, _mountTest.default)(_.Radio);
  it('should emit "update:modelValue" event when radio icon or label is clicked', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee() {
    var onClick, wrapper, icon, label;
    return _regenerator().default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            onClick = jest.fn();
            wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Radio, {
              name: "a",
              onClick: onClick,
              defaultChecked: false
            }, "\u5355\u9009\u6846"));
            icon = wrapper.find('.rc-radio__icon');
            label = wrapper.find('.rc-radio__label');
            icon.simulate('click');
            expect(onClick).toHaveBeenCalledTimes(1);
            _context.next = 8;
            return wrapper.setProps({
              checked: false
            });

          case 8:
            label.simulate('click');
            expect(onClick).toHaveBeenCalledTimes(2);

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  it('should not emit "update:modelValue" event when radio icon is disabled and clicked', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee2() {
    var onChange, wrapper;
    return _regenerator().default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            onChange = jest.fn();
            wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Radio, {
              name: "a",
              onChange: onChange,
              defaultChecked: true,
              disabled: true
            }, "\u5355\u9009\u6846"));
            wrapper.find('.rc-radio__icon').simulate('click');
            expect(onChange).not.toHaveBeenCalled();

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  it('should render "rc-radio--label-disabled" class when using label-disabled prop', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Radio, {
      name: "a",
      defaultChecked: true,
      labelDisabled: true
    }, "\u5355\u9009\u6846"));
    expect(wrapper.find('.rc-radio--label-disabled')).toBeTruthy();
  });
  it('should not emit "update:modelValue" event when label is disabled and clicked', function () {
    var onChange = jest.fn();
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Radio, {
      name: "a",
      onChange: onChange,
      defaultChecked: true,
      labelDisabled: true
    }, "\u5355\u9009\u6846"));
    var label = wrapper.find('.rc-radio__label');
    label.simulate('click');
    expect(onChange).not.toHaveBeenCalled();
  });
  it('should adjust label position when using label-position prop', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Radio, {
      name: "a",
      defaultChecked: true,
      labelPosition: "left"
    }, "\u5355\u9009\u6846"));
    expect(wrapper.find('.rc-radio__label--left')).toBeTruthy();
  });
  it('should emit click event when radio icon is clicked', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee3() {
    var onClick, wrapper;
    return _regenerator().default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            onClick = jest.fn();
            wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Radio, {
              name: "a",
              defaultChecked: true,
              onClick: onClick
            }, "\u5355\u9009\u6846"));
            wrapper.simulate('click');
            expect(onClick).toHaveBeenCalled();

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
});